/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/kinematics/kinematics_msgs/msg/KinematicSolverInfo.msg.  Do not edit! */
#ifndef KINEMATICS_MSGS_KINEMATICSOLVERINFO_H
#define KINEMATICS_MSGS_KINEMATICSOLVERINFO_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "motion_planning_msgs/JointLimits.h"

namespace kinematics_msgs
{

//! \htmlinclude KinematicSolverInfo.msg.html

class KinematicSolverInfo : public ros::Message
{
public:
  typedef boost::shared_ptr<KinematicSolverInfo> Ptr;
  typedef boost::shared_ptr<KinematicSolverInfo const> ConstPtr;

  typedef std::vector<std::string> _joint_names_type;
  typedef std::vector<motion_planning_msgs::JointLimits> _limits_type;
  typedef std::vector<std::string> _link_names_type;

  std::vector<std::string> joint_names;
  std::vector<motion_planning_msgs::JointLimits> limits;
  std::vector<std::string> link_names;

  KinematicSolverInfo() : ros::Message()
  {
  }
  KinematicSolverInfo(const KinematicSolverInfo &copy) : ros::Message()
  {
    (void)copy;
    joint_names = copy.joint_names;
    limits = copy.limits;
    link_names = copy.link_names;
  }
  KinematicSolverInfo &operator =(const KinematicSolverInfo &copy)
  {
    if (this == &copy)
      return *this;
    joint_names.clear();
    limits.clear();
    link_names.clear();
    joint_names = copy.joint_names;
    limits = copy.limits;
    link_names = copy.link_names;
    return *this;
  }
  virtual ~KinematicSolverInfo() 
  {
    joint_names.clear();
    limits.clear();
    link_names.clear();
  }
  inline static std::string __s_getDataType() { return std::string("kinematics_msgs/KinematicSolverInfo"); }
  inline static std::string __s_getMD5Sum() { return std::string("a90a53667d3b432ff157e1d9f6f2b207"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A list of joints in the kinematic tree\n"
    "string[] joint_names\n"
    "# A list of joint limits corresponding to the joint names\n"
    "motion_planning_msgs/JointLimits[] limits\n"
    "# A list of links that the kinematics node provides solutions for\n"
    "string[] link_names\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/JointLimits\n"
    "# This message contains information about limits of a particular joint (or control dimension)\n"
    "string joint_name\n"
    "\n"
    "# true if the joint has position limits\n"
    "uint8 has_position_limits\n"
    "\n"
    "# min and max position limits\n"
    "float64 min_position\n"
    "float64 max_position\n"
    "\n"
    "# true if joint has velocity limits\n"
    "uint8 has_velocity_limits\n"
    "\n"
    "# max velocity limit\n"
    "float64 max_velocity\n"
    "# min_velocity is assumed to be -max_velocity\n"
    "\n"
    "# true if joint has acceleration limits\n"
    "uint8 has_acceleration_limits\n"
    "# max acceleration limit\n"
    "float64 max_acceleration\n"
    "# min_acceleration is assumed to be -max_acceleration\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_joint_names_size(uint32_t __ros_new_size)
  {
    this->joint_names.resize(__ros_new_size);
  }
  inline uint32_t get_joint_names_size() const { return joint_names.size(); }
  uint32_t calc_joint_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_names_size = joint_names.size();
    for (size_t i = 0; i < joint_names_size; i++)
      l += 4 + joint_names[i].length();
    return l;
  }
  inline void get_joint_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->joint_names;
  }
  inline void set_joint_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->joint_names = __ros_vec;
  }
  void set_limits_size(uint32_t __ros_new_size)
  {
    this->limits.resize(__ros_new_size);
  }
  inline uint32_t get_limits_size() const { return limits.size(); }
  uint32_t calc_limits_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t limits_size = limits.size();
    for (size_t i = 0; i < limits_size; i++)
      l += limits[i].serializationLength();
    return l;
  }
  inline void get_limits_vec (std::vector<motion_planning_msgs::JointLimits> &__ros_vec) const
  {
    __ros_vec = this->limits;
  }
  inline void set_limits_vec(const std::vector<motion_planning_msgs::JointLimits> &__ros_vec)
  {
    this->limits = __ros_vec;
  }
  void set_link_names_size(uint32_t __ros_new_size)
  {
    this->link_names.resize(__ros_new_size);
  }
  inline uint32_t get_link_names_size() const { return link_names.size(); }
  uint32_t calc_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t link_names_size = link_names.size();
    for (size_t i = 0; i < link_names_size; i++)
      l += 4 + link_names[i].length();
    return l;
  }
  inline void get_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->link_names;
  }
  inline void set_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->link_names = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_joint_names_array_serialization_len(); // joint_names
    __l += 4 + calc_limits_array_serialization_len(); // limits
    __l += 4 + calc_link_names_array_serialization_len(); // link_names
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __joint_names_size = joint_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len = joint_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_names[i].c_str(), __ros_joint_names_i__len);
    }
    uint32_t __limits_size = limits.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __limits_size);
    for (size_t i = 0; i < __limits_size; i++)
      write_ptr = limits[i].serialize(write_ptr, seq);
    uint32_t __link_names_size = link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len = link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, link_names[i].c_str(), __ros_link_names_i__len);
    }
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __joint_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_names_size);
    set_joint_names_size(__joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_names_i__len);
    joint_names[i] = std::string((const char *)read_ptr, __ros_joint_names_i__len);
    read_ptr += __ros_joint_names_i__len;
    }
    uint32_t __limits_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __limits_size);
    set_limits_size(__limits_size);
    for (size_t i = 0; i < __limits_size; i++)
      read_ptr = limits[i].deserialize(read_ptr);
    uint32_t __link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __link_names_size);
    set_link_names_size(__link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_link_names_i__len);
    link_names[i] = std::string((const char *)read_ptr, __ros_link_names_i__len);
    read_ptr += __ros_link_names_i__len;
    }
    return read_ptr;
  }
};

typedef boost::shared_ptr<KinematicSolverInfo> KinematicSolverInfoPtr;
typedef boost::shared_ptr<KinematicSolverInfo const> KinematicSolverInfoConstPtr;


}

#endif
