/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/kinematics/kinematics_msgs/msg/PositionIKRequest.msg.  Do not edit! */
#ifndef KINEMATICS_MSGS_POSITIONIKREQUEST_H
#define KINEMATICS_MSGS_POSITIONIKREQUEST_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"
#include "sensor_msgs/JointState.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"

namespace kinematics_msgs
{

//! \htmlinclude PositionIKRequest.msg.html

class PositionIKRequest : public ros::Message
{
public:
  typedef boost::shared_ptr<PositionIKRequest> Ptr;
  typedef boost::shared_ptr<PositionIKRequest const> ConstPtr;

  typedef std::string _ik_link_name_type;
  typedef geometry_msgs::PoseStamped _pose_stamped_type;
  typedef motion_planning_msgs::RobotState _ik_seed_state_type;
  typedef motion_planning_msgs::RobotState _robot_state_type;

  std::string ik_link_name;
  geometry_msgs::PoseStamped pose_stamped;
  motion_planning_msgs::RobotState ik_seed_state;
  motion_planning_msgs::RobotState robot_state;

  PositionIKRequest() : ros::Message()
  {
  }
  PositionIKRequest(const PositionIKRequest &copy) : ros::Message(),
    ik_link_name(copy.ik_link_name),
    pose_stamped(copy.pose_stamped),
    ik_seed_state(copy.ik_seed_state),
    robot_state(copy.robot_state)
  {
    (void)copy;
  }
  PositionIKRequest &operator =(const PositionIKRequest &copy)
  {
    if (this == &copy)
      return *this;
    ik_link_name = copy.ik_link_name;
    pose_stamped = copy.pose_stamped;
    ik_seed_state = copy.ik_seed_state;
    robot_state = copy.robot_state;
    return *this;
  }
  virtual ~PositionIKRequest() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("kinematics_msgs/PositionIKRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string("8f1be5983a34f5b4de6f72e986032fea"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A Position IK request message\n"
    "# The name of the link for which we are computing IK\n"
    "string ik_link_name\n"
    "\n"
    "# The (stamped) pose of the link\n"
    "geometry_msgs/PoseStamped pose_stamped\n"
    "\n"
    "# A RobotState consisting of hint/seed positions for the IK computation. \n"
    "# These may be used to seed the IK search. \n"
    "# The seed state MUST contain state for all joints to be used by the IK solver\n"
    "# to compute IK. The list of joints that the IK solver deals with can be found using\n"
    "# the kinematics_msgs/GetKinematicTreeInfo\n"
    "motion_planning_msgs/RobotState ik_seed_state\n"
    "\n"
    "# Additional state information can be provided here to specify the starting positions \n"
    "# of other joints/links on the robot.\n"
    "motion_planning_msgs/RobotState robot_state\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + ik_link_name.length(); // ik_link_name
    __l += pose_stamped.serializationLength(); // pose_stamped
    __l += ik_seed_state.serializationLength(); // ik_seed_state
    __l += robot_state.serializationLength(); // robot_state
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_ik_link_name_len = ik_link_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_ik_link_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, ik_link_name.c_str(), __ros_ik_link_name_len);
    write_ptr = pose_stamped.serialize(write_ptr, seq);
    write_ptr = ik_seed_state.serialize(write_ptr, seq);
    write_ptr = robot_state.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_ik_link_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_ik_link_name_len);
    ik_link_name = std::string((const char *)read_ptr, __ros_ik_link_name_len);
    read_ptr += __ros_ik_link_name_len;
    read_ptr = pose_stamped.deserialize(read_ptr);
    read_ptr = ik_seed_state.deserialize(read_ptr);
    read_ptr = robot_state.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PositionIKRequest> PositionIKRequestPtr;
typedef boost::shared_ptr<PositionIKRequest const> PositionIKRequestConstPtr;


}

#endif
