# autogenerated by genmsg_py from KinematicSolverInfo.msg. Do not edit.
import roslib.message
import struct

import motion_planning_msgs.msg

class KinematicSolverInfo(roslib.message.Message):
  _md5sum = "a90a53667d3b432ff157e1d9f6f2b207"
  _type = "kinematics_msgs/KinematicSolverInfo"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# A list of joints in the kinematic tree
string[] joint_names
# A list of joint limits corresponding to the joint names
motion_planning_msgs/JointLimits[] limits
# A list of links that the kinematics node provides solutions for
string[] link_names

================================================================================
MSG: motion_planning_msgs/JointLimits
# This message contains information about limits of a particular joint (or control dimension)
string joint_name

# true if the joint has position limits
uint8 has_position_limits

# min and max position limits
float64 min_position
float64 max_position

# true if joint has velocity limits
uint8 has_velocity_limits

# max velocity limit
float64 max_velocity
# min_velocity is assumed to be -max_velocity

# true if joint has acceleration limits
uint8 has_acceleration_limits
# max acceleration limit
float64 max_acceleration
# min_acceleration is assumed to be -max_acceleration

"""
  __slots__ = ['joint_names','limits','link_names']
  _slot_types = ['string[]','motion_planning_msgs/JointLimits[]','string[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   joint_names,limits,link_names
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(KinematicSolverInfo, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_names is None:
        self.joint_names = []
      if self.limits is None:
        self.limits = []
      if self.link_names is None:
        self.link_names = []
    else:
      self.joint_names = []
      self.limits = []
      self.link_names = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.limits
      length = len(self.limits)
      buff.write(struct.pack('<I', length))
      for val1 in self.limits:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<B2dBdBd', val1.has_position_limits, val1.min_position, val1.max_position, val1.has_velocity_limits, val1.max_velocity, val1.has_acceleration_limits, val1.max_acceleration))
      #serialize self.link_names
      length = len(self.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.limits
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.limits = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointLimits()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 35
        (val1.has_position_limits, val1.min_position, val1.max_position, val1.has_velocity_limits, val1.max_velocity, val1.has_acceleration_limits, val1.max_acceleration,) = struct.unpack('<B2dBdBd',str[start:end])
        self.limits.append(val1)
      #deserialize self.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.link_names.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.limits
      length = len(self.limits)
      buff.write(struct.pack('<I', length))
      for val1 in self.limits:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<B2dBdBd', val1.has_position_limits, val1.min_position, val1.max_position, val1.has_velocity_limits, val1.max_velocity, val1.has_acceleration_limits, val1.max_acceleration))
      #serialize self.link_names
      length = len(self.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.limits
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.limits = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointLimits()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 35
        (val1.has_position_limits, val1.min_position, val1.max_position, val1.has_velocity_limits, val1.max_velocity, val1.has_acceleration_limits, val1.max_acceleration,) = struct.unpack('<B2dBdBd',str[start:end])
        self.limits.append(val1)
      #deserialize self.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.link_names.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

