# autogenerated by genmsg_py from GetPositionIKRequest.msg. Do not edit.
import roslib.message
import struct

import kinematics_msgs.msg
import motion_planning_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import roslib.msg
import roslib.rostime

class GetPositionIKRequest(roslib.message.Message):
  _md5sum = "c1e956c96a20b40f07f8e2bb604a6632"
  _type = "kinematics_msgs/GetPositionIKRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

kinematics_msgs/PositionIKRequest ik_request

duration timeout

================================================================================
MSG: kinematics_msgs/PositionIKRequest
# A Position IK request message
# The name of the link for which we are computing IK
string ik_link_name

# The (stamped) pose of the link
geometry_msgs/PoseStamped pose_stamped

# A RobotState consisting of hint/seed positions for the IK computation. 
# These may be used to seed the IK search. 
# The seed state MUST contain state for all joints to be used by the IK solver
# to compute IK. The list of joints that the IK solver deals with can be found using
# the kinematics_msgs/GetKinematicTreeInfo
motion_planning_msgs/RobotState ik_seed_state

# Additional state information can be provided here to specify the starting positions 
# of other joints/links on the robot.
motion_planning_msgs/RobotState robot_state

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

"""
  __slots__ = ['ik_request','timeout']
  _slot_types = ['kinematics_msgs/PositionIKRequest','duration']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   ik_request,timeout
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GetPositionIKRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.ik_request is None:
        self.ik_request = kinematics_msgs.msg.PositionIKRequest()
      if self.timeout is None:
        self.timeout = roslib.rostime.Duration()
    else:
      self.ik_request = kinematics_msgs.msg.PositionIKRequest()
      self.timeout = roslib.rostime.Duration()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.ik_request.ik_link_name)
      #serialize self.ik_request.ik_link_name
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_link_name))
      buff.write(struct.pack('<3I', self.ik_request.pose_stamped.header.seq, self.ik_request.pose_stamped.header.stamp.secs, self.ik_request.pose_stamped.header.stamp.nsecs))
      length = len(self.ik_request.pose_stamped.header.frame_id)
      #serialize self.ik_request.pose_stamped.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.pose_stamped.header.frame_id))
      buff.write(struct.pack('<7d3I', self.ik_request.pose_stamped.pose.position.x, self.ik_request.pose_stamped.pose.position.y, self.ik_request.pose_stamped.pose.position.z, self.ik_request.pose_stamped.pose.orientation.x, self.ik_request.pose_stamped.pose.orientation.y, self.ik_request.pose_stamped.pose.orientation.z, self.ik_request.pose_stamped.pose.orientation.w, self.ik_request.ik_seed_state.joint_state.header.seq, self.ik_request.ik_seed_state.joint_state.header.stamp.secs, self.ik_request.ik_seed_state.joint_state.header.stamp.nsecs))
      length = len(self.ik_request.ik_seed_state.joint_state.header.frame_id)
      #serialize self.ik_request.ik_seed_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.joint_state.header.frame_id))
      #serialize self.ik_request.ik_seed_state.joint_state.name
      length = len(self.ik_request.ik_seed_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.ik_request.ik_seed_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.ik_request.ik_seed_state.joint_state.position
      length = len(self.ik_request.ik_seed_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_request.ik_seed_state.joint_state.position))
      #serialize self.ik_request.ik_seed_state.joint_state.velocity
      length = len(self.ik_request.ik_seed_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_request.ik_seed_state.joint_state.velocity))
      #serialize self.ik_request.ik_seed_state.joint_state.effort
      length = len(self.ik_request.ik_seed_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_request.ik_seed_state.joint_state.effort))
      buff.write(struct.pack('<2I', self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.secs, self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name)
      #serialize self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name))
      length = len(self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id)
      #serialize self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id))
      length = len(self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id)
      #serialize self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d3I', self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.w, self.ik_request.robot_state.joint_state.header.seq, self.ik_request.robot_state.joint_state.header.stamp.secs, self.ik_request.robot_state.joint_state.header.stamp.nsecs))
      length = len(self.ik_request.robot_state.joint_state.header.frame_id)
      #serialize self.ik_request.robot_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.joint_state.header.frame_id))
      #serialize self.ik_request.robot_state.joint_state.name
      length = len(self.ik_request.robot_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.ik_request.robot_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.ik_request.robot_state.joint_state.position
      length = len(self.ik_request.robot_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_request.robot_state.joint_state.position))
      #serialize self.ik_request.robot_state.joint_state.velocity
      length = len(self.ik_request.robot_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_request.robot_state.joint_state.velocity))
      #serialize self.ik_request.robot_state.joint_state.effort
      length = len(self.ik_request.robot_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_request.robot_state.joint_state.effort))
      buff.write(struct.pack('<2I', self.ik_request.robot_state.multi_dof_joint_state.stamp.secs, self.ik_request.robot_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.ik_request.robot_state.multi_dof_joint_state.joint_name)
      #serialize self.ik_request.robot_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.multi_dof_joint_state.joint_name))
      length = len(self.ik_request.robot_state.multi_dof_joint_state.frame_id)
      #serialize self.ik_request.robot_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.multi_dof_joint_state.frame_id))
      length = len(self.ik_request.robot_state.multi_dof_joint_state.child_frame_id)
      #serialize self.ik_request.robot_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d2i', self.ik_request.robot_state.multi_dof_joint_state.pose.position.x, self.ik_request.robot_state.multi_dof_joint_state.pose.position.y, self.ik_request.robot_state.multi_dof_joint_state.pose.position.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.w, self.timeout.secs, self.timeout.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.ik_request is None:
        self.ik_request = kinematics_msgs.msg.PositionIKRequest()
      if self.timeout is None:
        self.timeout = roslib.rostime.Duration()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_link_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_link_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.ik_request.pose_stamped.header.seq, self.ik_request.pose_stamped.header.stamp.secs, self.ik_request.pose_stamped.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.pose_stamped.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.ik_request.pose_stamped.pose.position.x, self.ik_request.pose_stamped.pose.position.y, self.ik_request.pose_stamped.pose.position.z, self.ik_request.pose_stamped.pose.orientation.x, self.ik_request.pose_stamped.pose.orientation.y, self.ik_request.pose_stamped.pose.orientation.z, self.ik_request.pose_stamped.pose.orientation.w, self.ik_request.ik_seed_state.joint_state.header.seq, self.ik_request.ik_seed_state.joint_state.header.stamp.secs, self.ik_request.ik_seed_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.ik_seed_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ik_request.ik_seed_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.ik_request.ik_seed_state.joint_state.name.append(val1)
      #deserialize self.ik_request.ik_seed_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.ik_seed_state.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.ik_seed_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.ik_seed_state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.ik_seed_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.ik_seed_state.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.secs, self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.w, self.ik_request.robot_state.joint_state.header.seq, self.ik_request.robot_state.joint_state.header.stamp.secs, self.ik_request.robot_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.robot_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ik_request.robot_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.ik_request.robot_state.joint_state.name.append(val1)
      #deserialize self.ik_request.robot_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.robot_state.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.robot_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.robot_state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.robot_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.robot_state.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.ik_request.robot_state.multi_dof_joint_state.stamp.secs, self.ik_request.robot_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 64
      (self.ik_request.robot_state.multi_dof_joint_state.pose.position.x, self.ik_request.robot_state.multi_dof_joint_state.pose.position.y, self.ik_request.robot_state.multi_dof_joint_state.pose.position.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.w, self.timeout.secs, self.timeout.nsecs,) = struct.unpack('<7d2i',str[start:end])
      self.timeout.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.ik_request.ik_link_name)
      #serialize self.ik_request.ik_link_name
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_link_name))
      buff.write(struct.pack('<3I', self.ik_request.pose_stamped.header.seq, self.ik_request.pose_stamped.header.stamp.secs, self.ik_request.pose_stamped.header.stamp.nsecs))
      length = len(self.ik_request.pose_stamped.header.frame_id)
      #serialize self.ik_request.pose_stamped.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.pose_stamped.header.frame_id))
      buff.write(struct.pack('<7d3I', self.ik_request.pose_stamped.pose.position.x, self.ik_request.pose_stamped.pose.position.y, self.ik_request.pose_stamped.pose.position.z, self.ik_request.pose_stamped.pose.orientation.x, self.ik_request.pose_stamped.pose.orientation.y, self.ik_request.pose_stamped.pose.orientation.z, self.ik_request.pose_stamped.pose.orientation.w, self.ik_request.ik_seed_state.joint_state.header.seq, self.ik_request.ik_seed_state.joint_state.header.stamp.secs, self.ik_request.ik_seed_state.joint_state.header.stamp.nsecs))
      length = len(self.ik_request.ik_seed_state.joint_state.header.frame_id)
      #serialize self.ik_request.ik_seed_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.joint_state.header.frame_id))
      #serialize self.ik_request.ik_seed_state.joint_state.name
      length = len(self.ik_request.ik_seed_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.ik_request.ik_seed_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.ik_request.ik_seed_state.joint_state.position
      length = len(self.ik_request.ik_seed_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_request.ik_seed_state.joint_state.position.tostring())
      #serialize self.ik_request.ik_seed_state.joint_state.velocity
      length = len(self.ik_request.ik_seed_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_request.ik_seed_state.joint_state.velocity.tostring())
      #serialize self.ik_request.ik_seed_state.joint_state.effort
      length = len(self.ik_request.ik_seed_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_request.ik_seed_state.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.secs, self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name)
      #serialize self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name))
      length = len(self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id)
      #serialize self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id))
      length = len(self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id)
      #serialize self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d3I', self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.w, self.ik_request.robot_state.joint_state.header.seq, self.ik_request.robot_state.joint_state.header.stamp.secs, self.ik_request.robot_state.joint_state.header.stamp.nsecs))
      length = len(self.ik_request.robot_state.joint_state.header.frame_id)
      #serialize self.ik_request.robot_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.joint_state.header.frame_id))
      #serialize self.ik_request.robot_state.joint_state.name
      length = len(self.ik_request.robot_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.ik_request.robot_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.ik_request.robot_state.joint_state.position
      length = len(self.ik_request.robot_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_request.robot_state.joint_state.position.tostring())
      #serialize self.ik_request.robot_state.joint_state.velocity
      length = len(self.ik_request.robot_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_request.robot_state.joint_state.velocity.tostring())
      #serialize self.ik_request.robot_state.joint_state.effort
      length = len(self.ik_request.robot_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_request.robot_state.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.ik_request.robot_state.multi_dof_joint_state.stamp.secs, self.ik_request.robot_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.ik_request.robot_state.multi_dof_joint_state.joint_name)
      #serialize self.ik_request.robot_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.multi_dof_joint_state.joint_name))
      length = len(self.ik_request.robot_state.multi_dof_joint_state.frame_id)
      #serialize self.ik_request.robot_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.multi_dof_joint_state.frame_id))
      length = len(self.ik_request.robot_state.multi_dof_joint_state.child_frame_id)
      #serialize self.ik_request.robot_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_request.robot_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d2i', self.ik_request.robot_state.multi_dof_joint_state.pose.position.x, self.ik_request.robot_state.multi_dof_joint_state.pose.position.y, self.ik_request.robot_state.multi_dof_joint_state.pose.position.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.w, self.timeout.secs, self.timeout.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.ik_request is None:
        self.ik_request = kinematics_msgs.msg.PositionIKRequest()
      if self.timeout is None:
        self.timeout = roslib.rostime.Duration()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_link_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_link_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.ik_request.pose_stamped.header.seq, self.ik_request.pose_stamped.header.stamp.secs, self.ik_request.pose_stamped.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.pose_stamped.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.ik_request.pose_stamped.pose.position.x, self.ik_request.pose_stamped.pose.position.y, self.ik_request.pose_stamped.pose.position.z, self.ik_request.pose_stamped.pose.orientation.x, self.ik_request.pose_stamped.pose.orientation.y, self.ik_request.pose_stamped.pose.orientation.z, self.ik_request.pose_stamped.pose.orientation.w, self.ik_request.ik_seed_state.joint_state.header.seq, self.ik_request.ik_seed_state.joint_state.header.stamp.secs, self.ik_request.ik_seed_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.ik_seed_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ik_request.ik_seed_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.ik_request.ik_seed_state.joint_state.name.append(val1)
      #deserialize self.ik_request.ik_seed_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.ik_seed_state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.ik_request.ik_seed_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.ik_seed_state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.ik_request.ik_seed_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.ik_seed_state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.secs, self.ik_request.ik_seed_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.ik_seed_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.position.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.ik_seed_state.multi_dof_joint_state.pose.orientation.w, self.ik_request.robot_state.joint_state.header.seq, self.ik_request.robot_state.joint_state.header.stamp.secs, self.ik_request.robot_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_request.robot_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ik_request.robot_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.ik_request.robot_state.joint_state.name.append(val1)
      #deserialize self.ik_request.robot_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.robot_state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.ik_request.robot_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.robot_state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.ik_request.robot_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_request.robot_state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.ik_request.robot_state.multi_dof_joint_state.stamp.secs, self.ik_request.robot_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_request.robot_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_request.robot_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 64
      (self.ik_request.robot_state.multi_dof_joint_state.pose.position.x, self.ik_request.robot_state.multi_dof_joint_state.pose.position.y, self.ik_request.robot_state.multi_dof_joint_state.pose.position.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.x, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.y, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.z, self.ik_request.robot_state.multi_dof_joint_state.pose.orientation.w, self.timeout.secs, self.timeout.nsecs,) = struct.unpack('<7d2i',str[start:end])
      self.timeout.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from GetPositionIKResponse.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import roslib.rostime
import motion_planning_msgs.msg
import sensor_msgs.msg

class GetPositionIKResponse(roslib.message.Message):
  _md5sum = "ad1a4d00870810eeaf17b3f951dcb66b"
  _type = "kinematics_msgs/GetPositionIKResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

motion_planning_msgs/RobotState solution

motion_planning_msgs/ArmNavigationErrorCodes error_code



================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/ArmNavigationErrorCodes
int32 val

# overall behavior
int32 PLANNING_FAILED=-1
int32 SUCCESS=1
int32 TIMED_OUT=-2

# start state errors
int32 START_STATE_IN_COLLISION=-3
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4

# goal errors
int32 GOAL_IN_COLLISION=-5
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6

# robot state
int32 INVALID_ROBOT_STATE=-7
int32 INCOMPLETE_ROBOT_STATE=-8

# planning request errors
int32 INVALID_PLANNER_ID=-9
int32 INVALID_NUM_PLANNING_ATTEMPTS=-10
int32 INVALID_ALLOWED_PLANNING_TIME=-11
int32 INVALID_GROUP_NAME=-12
int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13
int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14
int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15
int32 INVALID_PATH_JOINT_CONSTRAINTS=-16
int32 INVALID_PATH_POSITION_CONSTRAINTS=-17
int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18

# state/trajectory monitor errors
int32 INVALID_TRAJECTORY=-19
int32 INVALID_INDEX=-20
int32 JOINT_LIMITS_VIOLATED=-21
int32 PATH_CONSTRAINTS_VIOLATED=-22
int32 COLLISION_CONSTRAINTS_VIOLATED=-23
int32 GOAL_CONSTRAINTS_VIOLATED=-24
int32 JOINTS_NOT_MOVING=-25
int32 TRAJECTORY_CONTROLLER_FAILED=-26

# system errors
int32 FRAME_TRANSFORM_FAILURE=-27
int32 COLLISION_CHECKING_UNAVAILABLE=-28
int32 ROBOT_STATE_STALE=-29
int32 SENSOR_INFO_STALE=-30

# kinematics errors
int32 NO_IK_SOLUTION=-31
int32 INVALID_LINK_NAME=-32
int32 IK_LINK_IN_COLLISION=-33
int32 NO_FK_SOLUTION=-34
int32 KINEMATICS_STATE_IN_COLLISION=-35

# general errors
int32 INVALID_TIMEOUT=-36


"""
  __slots__ = ['solution','error_code']
  _slot_types = ['motion_planning_msgs/RobotState','motion_planning_msgs/ArmNavigationErrorCodes']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   solution,error_code
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GetPositionIKResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.solution is None:
        self.solution = motion_planning_msgs.msg.RobotState()
      if self.error_code is None:
        self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()
    else:
      self.solution = motion_planning_msgs.msg.RobotState()
      self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.solution.joint_state.header.seq, self.solution.joint_state.header.stamp.secs, self.solution.joint_state.header.stamp.nsecs))
      length = len(self.solution.joint_state.header.frame_id)
      #serialize self.solution.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.solution.joint_state.header.frame_id))
      #serialize self.solution.joint_state.name
      length = len(self.solution.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.solution.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.solution.joint_state.position
      length = len(self.solution.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.solution.joint_state.position))
      #serialize self.solution.joint_state.velocity
      length = len(self.solution.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.solution.joint_state.velocity))
      #serialize self.solution.joint_state.effort
      length = len(self.solution.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.solution.joint_state.effort))
      buff.write(struct.pack('<2I', self.solution.multi_dof_joint_state.stamp.secs, self.solution.multi_dof_joint_state.stamp.nsecs))
      length = len(self.solution.multi_dof_joint_state.joint_name)
      #serialize self.solution.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.solution.multi_dof_joint_state.joint_name))
      length = len(self.solution.multi_dof_joint_state.frame_id)
      #serialize self.solution.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.solution.multi_dof_joint_state.frame_id))
      length = len(self.solution.multi_dof_joint_state.child_frame_id)
      #serialize self.solution.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.solution.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7di', self.solution.multi_dof_joint_state.pose.position.x, self.solution.multi_dof_joint_state.pose.position.y, self.solution.multi_dof_joint_state.pose.position.z, self.solution.multi_dof_joint_state.pose.orientation.x, self.solution.multi_dof_joint_state.pose.orientation.y, self.solution.multi_dof_joint_state.pose.orientation.z, self.solution.multi_dof_joint_state.pose.orientation.w, self.error_code.val))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.solution is None:
        self.solution = motion_planning_msgs.msg.RobotState()
      if self.error_code is None:
        self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()
      end = 0
      start = end
      end += 12
      (self.solution.joint_state.header.seq, self.solution.joint_state.header.stamp.secs, self.solution.joint_state.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.solution.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.solution.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.solution.joint_state.name.append(val1)
      #deserialize self.solution.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.solution.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.solution.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.solution.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.solution.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.solution.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.solution.multi_dof_joint_state.stamp.secs, self.solution.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 60
      (self.solution.multi_dof_joint_state.pose.position.x, self.solution.multi_dof_joint_state.pose.position.y, self.solution.multi_dof_joint_state.pose.position.z, self.solution.multi_dof_joint_state.pose.orientation.x, self.solution.multi_dof_joint_state.pose.orientation.y, self.solution.multi_dof_joint_state.pose.orientation.z, self.solution.multi_dof_joint_state.pose.orientation.w, self.error_code.val,) = struct.unpack('<7di',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.solution.joint_state.header.seq, self.solution.joint_state.header.stamp.secs, self.solution.joint_state.header.stamp.nsecs))
      length = len(self.solution.joint_state.header.frame_id)
      #serialize self.solution.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.solution.joint_state.header.frame_id))
      #serialize self.solution.joint_state.name
      length = len(self.solution.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.solution.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.solution.joint_state.position
      length = len(self.solution.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.solution.joint_state.position.tostring())
      #serialize self.solution.joint_state.velocity
      length = len(self.solution.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.solution.joint_state.velocity.tostring())
      #serialize self.solution.joint_state.effort
      length = len(self.solution.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.solution.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.solution.multi_dof_joint_state.stamp.secs, self.solution.multi_dof_joint_state.stamp.nsecs))
      length = len(self.solution.multi_dof_joint_state.joint_name)
      #serialize self.solution.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.solution.multi_dof_joint_state.joint_name))
      length = len(self.solution.multi_dof_joint_state.frame_id)
      #serialize self.solution.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.solution.multi_dof_joint_state.frame_id))
      length = len(self.solution.multi_dof_joint_state.child_frame_id)
      #serialize self.solution.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.solution.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7di', self.solution.multi_dof_joint_state.pose.position.x, self.solution.multi_dof_joint_state.pose.position.y, self.solution.multi_dof_joint_state.pose.position.z, self.solution.multi_dof_joint_state.pose.orientation.x, self.solution.multi_dof_joint_state.pose.orientation.y, self.solution.multi_dof_joint_state.pose.orientation.z, self.solution.multi_dof_joint_state.pose.orientation.w, self.error_code.val))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.solution is None:
        self.solution = motion_planning_msgs.msg.RobotState()
      if self.error_code is None:
        self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()
      end = 0
      start = end
      end += 12
      (self.solution.joint_state.header.seq, self.solution.joint_state.header.stamp.secs, self.solution.joint_state.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.solution.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.solution.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.solution.joint_state.name.append(val1)
      #deserialize self.solution.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.solution.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.solution.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.solution.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.solution.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.solution.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.solution.multi_dof_joint_state.stamp.secs, self.solution.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.solution.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.solution.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 60
      (self.solution.multi_dof_joint_state.pose.position.x, self.solution.multi_dof_joint_state.pose.position.y, self.solution.multi_dof_joint_state.pose.position.z, self.solution.multi_dof_joint_state.pose.orientation.x, self.solution.multi_dof_joint_state.pose.orientation.y, self.solution.multi_dof_joint_state.pose.orientation.z, self.solution.multi_dof_joint_state.pose.orientation.w, self.error_code.val,) = struct.unpack('<7di',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class GetPositionIK(roslib.message.ServiceDefinition):
  _type          = 'kinematics_msgs/GetPositionIK'
  _md5sum = 'c9652316cd8dadd064484c0d73764bc0'
  _request_class  = GetPositionIKRequest
  _response_class = GetPositionIKResponse
