/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/kinematics/kinematics_msgs/srv/GetConstraintAwarePositionIK.srv.  Do not edit! */
#ifndef SRV_KINEMATICS_MSGS_GETCONSTRAINTAWAREPOSITIONIK_H
#define SRV_KINEMATICS_MSGS_GETCONSTRAINTAWAREPOSITIONIK_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"
#include "sensor_msgs/JointState.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"
#include "kinematics_msgs/PositionIKRequest.h"
#include "geometric_shapes_msgs/Shape.h"
#include "motion_planning_msgs/AllowedContactSpecification.h"
#include "motion_planning_msgs/CollisionOperation.h"
#include "motion_planning_msgs/OrderedCollisionOperations.h"
#include "motion_planning_msgs/JointConstraint.h"
#include "motion_planning_msgs/PositionConstraint.h"
#include "motion_planning_msgs/OrientationConstraint.h"
#include "motion_planning_msgs/Constraints.h"

#include "roslib/Header.h"
#include "sensor_msgs/JointState.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"
#include "motion_planning_msgs/ArmNavigationErrorCodes.h"

namespace kinematics_msgs
{

struct GetConstraintAwarePositionIK
{

inline static std::string getDataType() { return "kinematics_msgs/GetConstraintAwarePositionIK"; }
inline static std::string getMD5Sum() { return "9ee2471440f97dcea3eea0b04394d088"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef kinematics_msgs::PositionIKRequest _ik_request_type;
  typedef std::vector<motion_planning_msgs::AllowedContactSpecification> _allowed_contacts_type;
  typedef motion_planning_msgs::OrderedCollisionOperations _ordered_collision_operations_type;
  typedef motion_planning_msgs::Constraints _constraints_type;
  typedef ros::Duration _timeout_type;

  kinematics_msgs::PositionIKRequest ik_request;
  std::vector<motion_planning_msgs::AllowedContactSpecification> allowed_contacts;
  motion_planning_msgs::OrderedCollisionOperations ordered_collision_operations;
  motion_planning_msgs::Constraints constraints;
  ros::Duration timeout;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    ik_request(copy.ik_request),
    ordered_collision_operations(copy.ordered_collision_operations),
    constraints(copy.constraints),
    timeout(copy.timeout)
  {
    (void)copy;
    allowed_contacts = copy.allowed_contacts;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    allowed_contacts.clear();
    ik_request = copy.ik_request;
    allowed_contacts = copy.allowed_contacts;
    ordered_collision_operations = copy.ordered_collision_operations;
    constraints = copy.constraints;
    timeout = copy.timeout;
    return *this;
  }
  virtual ~Request() 
  {
    allowed_contacts.clear();
  }
  inline static std::string __s_getDataType() { return std::string("kinematics_msgs/GetConstraintAwarePositionIKRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A service call to carry out an inverse kinematics computation\n"
    "# The inverse kinematics request\n"
    "kinematics_msgs/PositionIKRequest ik_request\n"
    "# A set of allowable contact regions\n"
    "motion_planning_msgs/AllowedContactSpecification[] allowed_contacts\n"
    "# A set of ordered collision operations to determine the resultant collision matrix to use\n"
    "motion_planning_msgs/OrderedCollisionOperations ordered_collision_operations\n"
    "# A set of constraints that the IK must obey\n"
    "motion_planning_msgs/Constraints constraints\n"
    "# Maximum allowed time for IK calculation\n"
    "duration timeout\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("9ee2471440f97dcea3eea0b04394d088"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("kinematics_msgs/GetConstraintAwarePositionIK"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_allowed_contacts_size(uint32_t __ros_new_size)
  {
    this->allowed_contacts.resize(__ros_new_size);
  }
  inline uint32_t get_allowed_contacts_size() const { return allowed_contacts.size(); }
  uint32_t calc_allowed_contacts_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t allowed_contacts_size = allowed_contacts.size();
    for (size_t i = 0; i < allowed_contacts_size; i++)
      l += allowed_contacts[i].serializationLength();
    return l;
  }
  inline void get_allowed_contacts_vec (std::vector<motion_planning_msgs::AllowedContactSpecification> &__ros_vec) const
  {
    __ros_vec = this->allowed_contacts;
  }
  inline void set_allowed_contacts_vec(const std::vector<motion_planning_msgs::AllowedContactSpecification> &__ros_vec)
  {
    this->allowed_contacts = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += ik_request.serializationLength(); // ik_request
    __l += 4 + calc_allowed_contacts_array_serialization_len(); // allowed_contacts
    __l += ordered_collision_operations.serializationLength(); // ordered_collision_operations
    __l += constraints.serializationLength(); // constraints
    __l += 8; // timeout
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = ik_request.serialize(write_ptr, seq);
    uint32_t __allowed_contacts_size = allowed_contacts.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __allowed_contacts_size);
    for (size_t i = 0; i < __allowed_contacts_size; i++)
      write_ptr = allowed_contacts[i].serialize(write_ptr, seq);
    write_ptr = ordered_collision_operations.serialize(write_ptr, seq);
    write_ptr = constraints.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timeout.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timeout.nsec);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = ik_request.deserialize(read_ptr);
    uint32_t __allowed_contacts_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __allowed_contacts_size);
    set_allowed_contacts_size(__allowed_contacts_size);
    for (size_t i = 0; i < __allowed_contacts_size; i++)
      read_ptr = allowed_contacts[i].deserialize(read_ptr);
    read_ptr = ordered_collision_operations.deserialize(read_ptr);
    read_ptr = constraints.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timeout.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timeout.nsec);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef motion_planning_msgs::RobotState _solution_type;
  typedef motion_planning_msgs::ArmNavigationErrorCodes _error_code_type;

  motion_planning_msgs::RobotState solution;
  motion_planning_msgs::ArmNavigationErrorCodes error_code;

  Response() : ros::Message()
  {
  }
  Response(const Response &copy) : ros::Message(),
    solution(copy.solution),
    error_code(copy.error_code)
  {
    (void)copy;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    solution = copy.solution;
    error_code = copy.error_code;
    return *this;
  }
  virtual ~Response() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("kinematics_msgs/GetConstraintAwarePositionIKResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# The returned solution \n"
    "motion_planning_msgs/RobotState solution\n"
    "motion_planning_msgs/ArmNavigationErrorCodes error_code\n"
    "\n"
    "================================================================================\n"
    "MSG: kinematics_msgs/PositionIKRequest\n"
    "# A Position IK request message\n"
    "# The name of the link for which we are computing IK\n"
    "string ik_link_name\n"
    "\n"
    "# The (stamped) pose of the link\n"
    "geometry_msgs/PoseStamped pose_stamped\n"
    "\n"
    "# A RobotState consisting of hint/seed positions for the IK computation. \n"
    "# These may be used to seed the IK search. \n"
    "# The seed state MUST contain state for all joints to be used by the IK solver\n"
    "# to compute IK. The list of joints that the IK solver deals with can be found using\n"
    "# the kinematics_msgs/GetKinematicTreeInfo\n"
    "motion_planning_msgs/RobotState ik_seed_state\n"
    "\n"
    "# Additional state information can be provided here to specify the starting positions \n"
    "# of other joints/links on the robot.\n"
    "motion_planning_msgs/RobotState robot_state\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/AllowedContactSpecification\n"
    "# The names of the regions\n"
    "string name\n"
    "\n"
    "# The shape of the region in the environment\n"
    "geometric_shapes_msgs/Shape shape\n"
    "\n"
    "# The pose of the space defining the region\n"
    "geometry_msgs/PoseStamped pose_stamped\n"
    "\n"
    "# The set of links that will be allowed to have penetration contact within this region\n"
    "string[] link_names\n"
    "\n"
    "# The maximum penetration depth allowed for every link\n"
    "float64 penetration_depth\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/OrderedCollisionOperations\n"
    "# A set of collision operations that will be performed in the order they are specified\n"
    "CollisionOperation[] collision_operations\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/CollisionOperation\n"
    "# A definition of a collision operation\n"
    "# E.g. (\"gripper\",COLLISION_SET_ALL,ENABLE) will enable collisions \n"
    "# between the gripper and all objects in the collision space\n"
    "\n"
    "string object1\n"
    "string object2\n"
    "string COLLISION_SET_ALL=\"all\"\n"
    "string COLLISION_SET_OBJECTS=\"objects\"\n"
    "string COLLISION_SET_ATTACHED_OBJECTS=\"attached\"\n"
    "\n"
    "# The penetration distance to which collisions are allowed. This is 0.0 by default.\n"
    "float64 penetration_distance\n"
    "\n"
    "# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above\n"
    "int32 operation\n"
    "int32 DISABLE=0\n"
    "int32 ENABLE=1\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/Constraints\n"
    "# This message contains a list of motion planning constraints.\n"
    "\n"
    "motion_planning_msgs/JointConstraint[] joint_constraints\n"
    "motion_planning_msgs/PositionConstraint[] position_constraints\n"
    "motion_planning_msgs/OrientationConstraint[] orientation_constraints\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/JointConstraint\n"
    "# Constrain the position of a joint to be within a certain bound\n"
    "string joint_name\n"
    "\n"
    "# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n"
    "float64 position\n"
    "float64 tolerance_above\n"
    "float64 tolerance_below\n"
    "\n"
    "# A weighting factor for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/PositionConstraint\n"
    "# This message contains the definition of a position constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The offset (in the link frame) for the target point on the link we are planning for\n"
    "geometry_msgs/Point target_point_offset\n"
    "\n"
    "# The nominal/target position for the point we are planning for\n"
    "geometry_msgs/Point position\n"
    "\n"
    "# The shape of the bounded region that constrains the position of the end-effector\n"
    "# This region is always centered at the position defined above\n"
    "geometric_shapes_msgs/Shape constraint_region_shape\n"
    "\n"
    "# The orientation of the bounded region that constrains the position of the end-effector. \n"
    "# This allows the specification of non-axis aligned constraints\n"
    "geometry_msgs/Quaternion constraint_region_orientation\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/OrientationConstraint\n"
    "# This message contains the definition of an orientation constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The type of the constraint\n"
    "int32 type\n"
    "int32 LINK_FRAME=0\n"
    "int32 HEADER_FRAME=1\n"
    "\n"
    "# The desired orientation of the robot link specified as a quaternion\n"
    "geometry_msgs/Quaternion orientation\n"
    "\n"
    "# optional RPY error tolerances specified if \n"
    "float64 absolute_roll_tolerance\n"
    "float64 absolute_pitch_tolerance\n"
    "float64 absolute_yaw_tolerance\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/ArmNavigationErrorCodes\n"
    "int32 val\n"
    "\n"
    "# overall behavior\n"
    "int32 PLANNING_FAILED=-1\n"
    "int32 SUCCESS=1\n"
    "int32 TIMED_OUT=-2\n"
    "\n"
    "# start state errors\n"
    "int32 START_STATE_IN_COLLISION=-3\n"
    "int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4\n"
    "\n"
    "# goal errors\n"
    "int32 GOAL_IN_COLLISION=-5\n"
    "int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6\n"
    "\n"
    "# robot state\n"
    "int32 INVALID_ROBOT_STATE=-7\n"
    "int32 INCOMPLETE_ROBOT_STATE=-8\n"
    "\n"
    "# planning request errors\n"
    "int32 INVALID_PLANNER_ID=-9\n"
    "int32 INVALID_NUM_PLANNING_ATTEMPTS=-10\n"
    "int32 INVALID_ALLOWED_PLANNING_TIME=-11\n"
    "int32 INVALID_GROUP_NAME=-12\n"
    "int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13\n"
    "int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14\n"
    "int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15\n"
    "int32 INVALID_PATH_JOINT_CONSTRAINTS=-16\n"
    "int32 INVALID_PATH_POSITION_CONSTRAINTS=-17\n"
    "int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18\n"
    "\n"
    "# state/trajectory monitor errors\n"
    "int32 INVALID_TRAJECTORY=-19\n"
    "int32 INVALID_INDEX=-20\n"
    "int32 JOINT_LIMITS_VIOLATED=-21\n"
    "int32 PATH_CONSTRAINTS_VIOLATED=-22\n"
    "int32 COLLISION_CONSTRAINTS_VIOLATED=-23\n"
    "int32 GOAL_CONSTRAINTS_VIOLATED=-24\n"
    "int32 JOINTS_NOT_MOVING=-25\n"
    "int32 TRAJECTORY_CONTROLLER_FAILED=-26\n"
    "\n"
    "# system errors\n"
    "int32 FRAME_TRANSFORM_FAILURE=-27\n"
    "int32 COLLISION_CHECKING_UNAVAILABLE=-28\n"
    "int32 ROBOT_STATE_STALE=-29\n"
    "int32 SENSOR_INFO_STALE=-30\n"
    "\n"
    "# kinematics errors\n"
    "int32 NO_IK_SOLUTION=-31\n"
    "int32 INVALID_LINK_NAME=-32\n"
    "int32 IK_LINK_IN_COLLISION=-33\n"
    "int32 NO_FK_SOLUTION=-34\n"
    "int32 KINEMATICS_STATE_IN_COLLISION=-35\n"
    "\n"
    "# general errors\n"
    "int32 INVALID_TIMEOUT=-36\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("9ee2471440f97dcea3eea0b04394d088"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("kinematics_msgs/GetConstraintAwarePositionIK"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += solution.serializationLength(); // solution
    __l += error_code.serializationLength(); // error_code
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = solution.serialize(write_ptr, seq);
    write_ptr = error_code.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = solution.deserialize(read_ptr);
    read_ptr = error_code.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
