/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/kinematics/kinematics_msgs/srv/GetPositionFK.srv.  Do not edit! */
#ifndef SRV_KINEMATICS_MSGS_GETPOSITIONFK_H
#define SRV_KINEMATICS_MSGS_GETPOSITIONFK_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/JointState.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"
#include "motion_planning_msgs/ArmNavigationErrorCodes.h"

namespace kinematics_msgs
{

struct GetPositionFK
{

inline static std::string getDataType() { return "kinematics_msgs/GetPositionFK"; }
inline static std::string getMD5Sum() { return "640a007f26dd5ba85530700c8cb863c6"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<std::string> _fk_link_names_type;
  typedef motion_planning_msgs::RobotState _robot_state_type;

  roslib::Header header;
  std::vector<std::string> fk_link_names;
  motion_planning_msgs::RobotState robot_state;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    header(copy.header),
    robot_state(copy.robot_state)
  {
    (void)copy;
    fk_link_names = copy.fk_link_names;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    fk_link_names.clear();
    header = copy.header;
    fk_link_names = copy.fk_link_names;
    robot_state = copy.robot_state;
    return *this;
  }
  virtual ~Request() 
  {
    fk_link_names.clear();
  }
  inline static std::string __s_getDataType() { return std::string("kinematics_msgs/GetPositionFKRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A service definition for a standard forward kinematics service\n"
    "# The frame_id in the header message is the frame in which \n"
    "# the forward kinematics poses will be returned\n"
    "Header header\n"
    "\n"
    "# A vector of link name for which forward kinematics must be computed\n"
    "string[] fk_link_names\n"
    "\n"
    "# A robot state consisting of joint names and joint positions to be used for forward kinematics\n"
    "motion_planning_msgs/RobotState robot_state\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("640a007f26dd5ba85530700c8cb863c6"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("kinematics_msgs/GetPositionFK"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_fk_link_names_size(uint32_t __ros_new_size)
  {
    this->fk_link_names.resize(__ros_new_size);
  }
  inline uint32_t get_fk_link_names_size() const { return fk_link_names.size(); }
  uint32_t calc_fk_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t fk_link_names_size = fk_link_names.size();
    for (size_t i = 0; i < fk_link_names_size; i++)
      l += 4 + fk_link_names[i].length();
    return l;
  }
  inline void get_fk_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->fk_link_names;
  }
  inline void set_fk_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->fk_link_names = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_fk_link_names_array_serialization_len(); // fk_link_names
    __l += robot_state.serializationLength(); // robot_state
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __fk_link_names_size = fk_link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __fk_link_names_size);
    for (size_t i = 0; i < __fk_link_names_size; i++)
    {
      unsigned __ros_fk_link_names_i__len = fk_link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_fk_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, fk_link_names[i].c_str(), __ros_fk_link_names_i__len);
    }
    write_ptr = robot_state.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __fk_link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __fk_link_names_size);
    set_fk_link_names_size(__fk_link_names_size);
    for (size_t i = 0; i < __fk_link_names_size; i++)
    {
      unsigned __ros_fk_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_fk_link_names_i__len);
    fk_link_names[i] = std::string((const char *)read_ptr, __ros_fk_link_names_i__len);
    read_ptr += __ros_fk_link_names_i__len;
    }
    read_ptr = robot_state.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef std::vector<geometry_msgs::PoseStamped> _pose_stamped_type;
  typedef std::vector<std::string> _fk_link_names_type;
  typedef motion_planning_msgs::ArmNavigationErrorCodes _error_code_type;

  std::vector<geometry_msgs::PoseStamped> pose_stamped;
  std::vector<std::string> fk_link_names;
  motion_planning_msgs::ArmNavigationErrorCodes error_code;

  Response() : ros::Message()
  {
  }
  Response(const Response &copy) : ros::Message(),
    error_code(copy.error_code)
  {
    (void)copy;
    pose_stamped = copy.pose_stamped;
    fk_link_names = copy.fk_link_names;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    pose_stamped.clear();
    fk_link_names.clear();
    pose_stamped = copy.pose_stamped;
    fk_link_names = copy.fk_link_names;
    error_code = copy.error_code;
    return *this;
  }
  virtual ~Response() 
  {
    pose_stamped.clear();
    fk_link_names.clear();
  }
  inline static std::string __s_getDataType() { return std::string("kinematics_msgs/GetPositionFKResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# The resultant vector of PoseStamped messages that contains the (stamped) poses of the requested links\n"
    "geometry_msgs/PoseStamped[] pose_stamped\n"
    "\n"
    "# The list of link names corresponding to the poses\n"
    "string[] fk_link_names\n"
    "\n"
    "motion_planning_msgs/ArmNavigationErrorCodes error_code\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/ArmNavigationErrorCodes\n"
    "int32 val\n"
    "\n"
    "# overall behavior\n"
    "int32 PLANNING_FAILED=-1\n"
    "int32 SUCCESS=1\n"
    "int32 TIMED_OUT=-2\n"
    "\n"
    "# start state errors\n"
    "int32 START_STATE_IN_COLLISION=-3\n"
    "int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4\n"
    "\n"
    "# goal errors\n"
    "int32 GOAL_IN_COLLISION=-5\n"
    "int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6\n"
    "\n"
    "# robot state\n"
    "int32 INVALID_ROBOT_STATE=-7\n"
    "int32 INCOMPLETE_ROBOT_STATE=-8\n"
    "\n"
    "# planning request errors\n"
    "int32 INVALID_PLANNER_ID=-9\n"
    "int32 INVALID_NUM_PLANNING_ATTEMPTS=-10\n"
    "int32 INVALID_ALLOWED_PLANNING_TIME=-11\n"
    "int32 INVALID_GROUP_NAME=-12\n"
    "int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13\n"
    "int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14\n"
    "int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15\n"
    "int32 INVALID_PATH_JOINT_CONSTRAINTS=-16\n"
    "int32 INVALID_PATH_POSITION_CONSTRAINTS=-17\n"
    "int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18\n"
    "\n"
    "# state/trajectory monitor errors\n"
    "int32 INVALID_TRAJECTORY=-19\n"
    "int32 INVALID_INDEX=-20\n"
    "int32 JOINT_LIMITS_VIOLATED=-21\n"
    "int32 PATH_CONSTRAINTS_VIOLATED=-22\n"
    "int32 COLLISION_CONSTRAINTS_VIOLATED=-23\n"
    "int32 GOAL_CONSTRAINTS_VIOLATED=-24\n"
    "int32 JOINTS_NOT_MOVING=-25\n"
    "int32 TRAJECTORY_CONTROLLER_FAILED=-26\n"
    "\n"
    "# system errors\n"
    "int32 FRAME_TRANSFORM_FAILURE=-27\n"
    "int32 COLLISION_CHECKING_UNAVAILABLE=-28\n"
    "int32 ROBOT_STATE_STALE=-29\n"
    "int32 SENSOR_INFO_STALE=-30\n"
    "\n"
    "# kinematics errors\n"
    "int32 NO_IK_SOLUTION=-31\n"
    "int32 INVALID_LINK_NAME=-32\n"
    "int32 IK_LINK_IN_COLLISION=-33\n"
    "int32 NO_FK_SOLUTION=-34\n"
    "int32 KINEMATICS_STATE_IN_COLLISION=-35\n"
    "\n"
    "# general errors\n"
    "int32 INVALID_TIMEOUT=-36\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("640a007f26dd5ba85530700c8cb863c6"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("kinematics_msgs/GetPositionFK"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_pose_stamped_size(uint32_t __ros_new_size)
  {
    this->pose_stamped.resize(__ros_new_size);
  }
  inline uint32_t get_pose_stamped_size() const { return pose_stamped.size(); }
  uint32_t calc_pose_stamped_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t pose_stamped_size = pose_stamped.size();
    for (size_t i = 0; i < pose_stamped_size; i++)
      l += pose_stamped[i].serializationLength();
    return l;
  }
  inline void get_pose_stamped_vec (std::vector<geometry_msgs::PoseStamped> &__ros_vec) const
  {
    __ros_vec = this->pose_stamped;
  }
  inline void set_pose_stamped_vec(const std::vector<geometry_msgs::PoseStamped> &__ros_vec)
  {
    this->pose_stamped = __ros_vec;
  }
  void set_fk_link_names_size(uint32_t __ros_new_size)
  {
    this->fk_link_names.resize(__ros_new_size);
  }
  inline uint32_t get_fk_link_names_size() const { return fk_link_names.size(); }
  uint32_t calc_fk_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t fk_link_names_size = fk_link_names.size();
    for (size_t i = 0; i < fk_link_names_size; i++)
      l += 4 + fk_link_names[i].length();
    return l;
  }
  inline void get_fk_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->fk_link_names;
  }
  inline void set_fk_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->fk_link_names = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_pose_stamped_array_serialization_len(); // pose_stamped
    __l += 4 + calc_fk_link_names_array_serialization_len(); // fk_link_names
    __l += error_code.serializationLength(); // error_code
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __pose_stamped_size = pose_stamped.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __pose_stamped_size);
    for (size_t i = 0; i < __pose_stamped_size; i++)
      write_ptr = pose_stamped[i].serialize(write_ptr, seq);
    uint32_t __fk_link_names_size = fk_link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __fk_link_names_size);
    for (size_t i = 0; i < __fk_link_names_size; i++)
    {
      unsigned __ros_fk_link_names_i__len = fk_link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_fk_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, fk_link_names[i].c_str(), __ros_fk_link_names_i__len);
    }
    write_ptr = error_code.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __pose_stamped_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __pose_stamped_size);
    set_pose_stamped_size(__pose_stamped_size);
    for (size_t i = 0; i < __pose_stamped_size; i++)
      read_ptr = pose_stamped[i].deserialize(read_ptr);
    uint32_t __fk_link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __fk_link_names_size);
    set_fk_link_names_size(__fk_link_names_size);
    for (size_t i = 0; i < __fk_link_names_size; i++)
    {
      unsigned __ros_fk_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_fk_link_names_i__len);
    fk_link_names[i] = std::string((const char *)read_ptr, __ros_fk_link_names_i__len);
    read_ptr += __ros_fk_link_names_i__len;
    }
    read_ptr = error_code.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
